////////////////////////////////////////////////////////////////////////////////
// Filename: positionclass.cpp
////////////////////////////////////////////////////////////////////////////////
#include "positionclass.h"


PositionClass::PositionClass()
{
    m_positionX = 0.0f;
    m_positionY = 0.0f;
    m_positionZ = 0.0f;

    m_rotationX = 0.0f;
    m_rotationY = 0.0f;
    m_rotationZ = 0.0f;
    
    m_frameTime = 0.0f;

    m_leftSpeed  = 0.0f;
    m_rightSpeed = 0.0f;
}


PositionClass::PositionClass(const PositionClass& other)
{
}


PositionClass::~PositionClass()
{
}


void PositionClass::SetPosition(float x, float y, float z)
{
    m_positionX = x;
    m_positionY = y;
    m_positionZ = z;
    return;
}


void PositionClass::SetRotation(float x, float y, float z)
{
    m_rotationX = x;
    m_rotationY = y;
    m_rotationZ = z;
    return;
}


void PositionClass::GetPosition(float& x, float& y, float& z)
{
    x = m_positionX;
    y = m_positionY;
    z = m_positionZ;
    return;
}


void PositionClass::GetRotation(float& x, float& y, float& z)
{
    x = m_rotationX;
    y = m_rotationY;
    z = m_rotationZ;
    return;
}


void PositionClass::SetFrameTime(float time)
{
    m_frameTime = time;
    return;
}


void PositionClass::MoveLeft(bool keydown)
{
    float radians;


    // Update the left speed movement based on the frame time and whether the user is holding the key down or not.
    if(keydown)
    {
        m_leftSpeed += m_frameTime * 1.0f;

        if(m_leftSpeed > (m_frameTime * 50.0f))
        {
            m_leftSpeed = m_frameTime * 50.0f;
        }
    }
    else
    {
        m_leftSpeed -= m_frameTime * 1.0f;

        if(m_leftSpeed < 0.0f)
        {
            m_leftSpeed = 0.0f;
        }
    }

    // Convert degrees to radians.
    radians = m_rotationY * 0.0174532925f;

    // Update the position.
    m_positionX -= cosf(radians) * m_leftSpeed;
    m_positionZ -= sinf(radians) * m_leftSpeed;

    return;
}


void PositionClass::MoveRight(bool keydown)
{
    float radians;


    // Update the right speed movement based on the frame time and whether the user is holding the key down or not.
    if(keydown)
    {
        m_rightSpeed += m_frameTime * 1.0f;

        if(m_rightSpeed > (m_frameTime * 50.0f))
        {
            m_rightSpeed = m_frameTime * 50.0f;
        }
    }
    else
    {
        m_rightSpeed -= m_frameTime * 1.0f;
    
        if(m_rightSpeed < 0.0f)
        {
            m_rightSpeed = 0.0f;
        }
    }

    // Convert degrees to radians.
    radians = m_rotationY * 0.0174532925f;

    // Update the position.
    m_positionX += cosf(radians) * m_rightSpeed;
    m_positionZ += sinf(radians) * m_rightSpeed;

    return;
}
